#include "core/utils/New.hpp"

#include <stdlib.h>

#include "core/utils/Utility.hpp"

void* operator new(size_t bytes, const NoThrow&) noexcept {
    return Core::allocate(bytes);
}

void* operator new[](size_t bytes, const NoThrow&) noexcept {
    return Core::allocate(bytes);
}

void operator delete(void* p) noexcept {
    free(p);
}

void operator delete[](void* p) noexcept {
    free(p);
}

void operator delete(void* p, size_t bytes) noexcept {
    (void)bytes;
    operator delete(p);
}

void operator delete[](void* p, size_t bytes) noexcept {
    (void)bytes;
    free(p);
}

void* operator new(size_t bytes, void* p) noexcept {
    (void)bytes;
    return p;
}
